diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
index 1e4d5e9b..0fa63d9b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -83,6 +84,13 @@ public class TwistyBandagedFused extends TwistyBandagedAbstract
     return ObjectType.BAN1_3.name();
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectSignature getSignature()
+    {
+    return new ObjectSignature(ObjectType.BAN1_3);
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public String getObjectName()
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedGeneric.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedGeneric.java
index bbb37be2..9ae77af4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedGeneric.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedGeneric.java
@@ -21,6 +21,7 @@ package org.distorted.objectlib.objects;
 
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 
 import java.io.InputStream;
@@ -30,7 +31,7 @@ import java.io.InputStream;
 public class TwistyBandagedGeneric extends TwistyBandagedAbstract
 {
   private static float[][] POS;
-  private static long mSignature;
+  private static ObjectSignature mSignature;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
@@ -62,7 +63,7 @@ public class TwistyBandagedGeneric extends TwistyBandagedAbstract
   public static void setPositions(float[][] positions)
     {
     POS = positions;
-    mSignature = -1;
+    mSignature = null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -110,20 +111,22 @@ public class TwistyBandagedGeneric extends TwistyBandagedAbstract
 
   public String getShortName()
     {
-    if( mSignature<0 ) mSignature = getSignature();
-    return ""+mSignature;
+    if( mSignature==null ) mSignature = getSignature();
+    int[] numLayers = getNumLayers();
+    int number = 100*numLayers[0]+10*numLayers[1]+numLayers[0];
+
+    return number+"_"+mSignature.getString();
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    if( mSignature<0 )
+    if( mSignature==null )
       {
-      mSignature = 0;
-      for(float[] pos : POS ) mSignature = markConnections(mSignature,pos);
+      int[] numLayers = getNumLayers();
+      mSignature = new ObjectSignature(numLayers[0],numLayers[1],numLayers[2],POS);
       }
-
     return mSignature;
     }
 
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyContainer.java b/src/main/java/org/distorted/objectlib/objects/TwistyContainer.java
index 19380bb2..3f08de5c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyContainer.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyContainer.java
@@ -25,6 +25,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeHexahedron;
@@ -344,9 +345,9 @@ public class TwistyContainer extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.CONT_2.ordinal();
+    return new ObjectSignature(ObjectType.CONT_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCrystal.java b/src/main/java/org/distorted/objectlib/objects/TwistyCrystal.java
index 7711bc8b..58ed3423 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCrystal.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCrystal.java
@@ -25,6 +25,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -245,9 +246,9 @@ public class TwistyCrystal extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.CRYS_3.ordinal();
+    return new ObjectSignature(ObjectType.CRYS_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
index 5c463917..71f6b1f6 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlCuboids;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -679,7 +680,7 @@ public class TwistyCuboid extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     int[] numLayers = getNumLayers();
 
@@ -690,22 +691,22 @@ public class TwistyCuboid extends ShapeHexahedron
       {
       case 2: switch(y)
                 {
-                case 2: return ObjectType.CUBE_2.ordinal();
-                case 3: return ObjectType.CU_232.ordinal();
+                case 2: return new ObjectSignature(ObjectType.CUBE_2);
+                case 3: return new ObjectSignature(ObjectType.CU_232);
                 }
       case 3: switch(y)
                 {
-                case 2: return ObjectType.CU_323.ordinal();
-                case 3: return ObjectType.CUBE_3.ordinal();
-                case 4: return ObjectType.CU_343.ordinal();
+                case 2: return new ObjectSignature(ObjectType.CU_323);
+                case 3: return new ObjectSignature(ObjectType.CUBE_3);
+                case 4: return new ObjectSignature(ObjectType.CU_343);
                 }
-      case 4: return ObjectType.CUBE_4.ordinal();
-      case 5: return ObjectType.CUBE_5.ordinal();
-      case 6: return ObjectType.CUBE_6.ordinal();
-      case 7: return ObjectType.CUBE_7.ordinal();
+      case 4: return new ObjectSignature(ObjectType.CUBE_4);
+      case 5: return new ObjectSignature(ObjectType.CUBE_5);
+      case 6: return new ObjectSignature(ObjectType.CUBE_6);
+      case 7: return new ObjectSignature(ObjectType.CUBE_7);
       }
 
-    return ObjectType.CUBE_3.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index e4f63ddd..20c183e0 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlOctahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -504,16 +505,16 @@ public class TwistyDiamond extends ShapeOctahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 2: return ObjectType.DIAM_2.ordinal();
-      case 3: return ObjectType.DIAM_3.ordinal();
-      case 4: return ObjectType.DIAM_4.ordinal();
+      case 2: return new ObjectSignature(ObjectType.DIAM_2);
+      case 3: return new ObjectSignature(ObjectType.DIAM_3);
+      case 4: return new ObjectSignature(ObjectType.DIAM_4);
       }
 
-    return ObjectType.DIAM_2.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
index f92b178a..4584f412 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.scrambling.ScrambleState;
 
@@ -105,9 +106,9 @@ public class TwistyDino4 extends TwistyDino
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.DIN4_3.ordinal();
+    return new ObjectSignature(ObjectType.DIN4_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
index c836725d..5cc25768 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
@@ -24,6 +24,7 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.scrambling.ScrambleState;
 
@@ -81,9 +82,9 @@ public class TwistyDino6 extends TwistyDino
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.DINO_3.ordinal();
+    return new ObjectSignature(ObjectType.DINO_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyFisher.java b/src/main/java/org/distorted/objectlib/objects/TwistyFisher.java
index b65ab8ce..9f951492 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyFisher.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyFisher.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeHexahedron;
@@ -412,9 +413,9 @@ public class TwistyFisher extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.FISH_3.ordinal();
+    return new ObjectSignature(ObjectType.FISH_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index 9c5be3bf..a689fc8e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -332,9 +333,9 @@ public class TwistyHelicopter extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.HELI_3.ordinal();
+    return new ObjectSignature(ObjectType.HELI_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 54eae00d..8ca4fc81 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -448,9 +449,9 @@ public class TwistyIvy extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.IVY_2.ordinal();
+    return new ObjectSignature(ObjectType.IVY_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index 2111b0d0..cf46f4f4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlTetrahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -374,9 +375,9 @@ public class TwistyJing extends ShapeTetrahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.JING_2.ordinal();
+    return new ObjectSignature(ObjectType.JING_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index 5bebe4bd..87b34be4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -29,6 +29,7 @@ import org.distorted.library.type.Static4D;
 import org.distorted.library.main.QuatHelper;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 
@@ -571,15 +572,15 @@ public class TwistyKilominx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 3: return ObjectType.KILO_3.ordinal();
-      case 5: return ObjectType.KILO_5.ordinal();
+      case 3: return new ObjectSignature(ObjectType.KILO_3);
+      case 5: return new ObjectSignature(ObjectType.KILO_5);
       }
 
-    return ObjectType.KILO_3.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -591,7 +592,7 @@ public class TwistyKilominx extends TwistyMinx
       case 3: return "Kilominx";
       case 5: return "Master Kilominx";
       }
-    return "Kilominx";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index da370996..a6446581 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -29,6 +29,7 @@ import org.distorted.library.type.Static4D;
 import org.distorted.library.main.QuatHelper;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 
@@ -492,15 +493,15 @@ public class TwistyMegaminx extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 3: return ObjectType.MEGA_3.ordinal();
-      case 5: return ObjectType.MEGA_5.ordinal();
+      case 3: return new ObjectSignature(ObjectType.MEGA_3);
+      case 5: return new ObjectSignature(ObjectType.MEGA_5);
       }
 
-    return ObjectType.MEGA_3.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index c0e755c9..d8d87bd3 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.scrambling.ScrambleState;
@@ -397,16 +398,16 @@ public class TwistyMirror extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 2: return ObjectType.MIRR_2.ordinal();
-      case 3: return ObjectType.MIRR_3.ordinal();
-      case 4: return ObjectType.MIRR_4.ordinal();
+      case 2: return new ObjectSignature(ObjectType.MIRR_2);
+      case 3: return new ObjectSignature(ObjectType.MIRR_3);
+      case 4: return new ObjectSignature(ObjectType.MIRR_4);
       }
 
-    return ObjectType.MIRR_2.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -419,7 +420,7 @@ public class TwistyMirror extends ShapeHexahedron
       case 3: return "Mirror Cube";
       case 4: return "Master Mirror Blocks";
       }
-    return "Pocket Mirror";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -432,7 +433,7 @@ public class TwistyMirror extends ShapeHexahedron
       case 3: return "Hidetoshi Takeji";
       case 4: return "Traiphum Prungtaengkit";
       }
-    return "Hidetoshi Takeji";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMorphix.java b/src/main/java/org/distorted/objectlib/objects/TwistyMorphix.java
index 20c6c9b7..c571033e 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMorphix.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMorphix.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.scrambling.ScrambleState;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.main.ShapeTetrahedron;
@@ -301,9 +302,9 @@ public class TwistyMorphix extends ShapeTetrahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.MORP_2.ordinal();
+    return new ObjectSignature(ObjectType.MORP_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPentultimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyPentultimate.java
index c0b61e91..17120f95 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPentultimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPentultimate.java
@@ -23,6 +23,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 import org.distorted.objectlib.helpers.ObjectFaceShape;
 import org.distorted.objectlib.helpers.ObjectShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.scrambling.ScrambleState;
 
@@ -363,9 +364,9 @@ public class TwistyPentultimate extends TwistyMinx
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.PENT_2.ordinal();
+    return new ObjectSignature(ObjectType.PENT_2);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index a31f66fc..0b472fb1 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlTetrahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -386,16 +387,16 @@ public class TwistyPyraminx extends ShapeTetrahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 3: return ObjectType.PYRA_3.ordinal();
-      case 4: return ObjectType.PYRA_4.ordinal();
-      case 5: return ObjectType.PYRA_5.ordinal();
+      case 3: return new ObjectSignature(ObjectType.PYRA_3);
+      case 4: return new ObjectSignature(ObjectType.PYRA_4);
+      case 5: return new ObjectSignature(ObjectType.PYRA_5);
       }
 
-    return ObjectType.PYRA_3.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -408,7 +409,7 @@ public class TwistyPyraminx extends ShapeTetrahedron
       case 4: return "Master Pyraminx";
       case 5: return "Professor's Pyraminx";
       }
-    return "Pyraminx";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -421,7 +422,7 @@ public class TwistyPyraminx extends ShapeTetrahedron
       case 4: return "Katsuhiko Okamoto";
       case 5: return "Timur Evbatyrov";
       }
-    return "Uwe Meffert";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index 41a4cfcf..aa0e7599 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -377,9 +378,9 @@ public class TwistyRedi extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.REDI_3.ordinal();
+    return new ObjectSignature(ObjectType.REDI_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index cb311873..be24ef7d 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -376,9 +377,9 @@ public class TwistyRex extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.REX_3.ordinal();
+    return new ObjectSignature(ObjectType.REX_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index 8918c417..fac99727 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -28,6 +28,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.touchcontrol.TouchControlHexahedron;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
@@ -509,15 +510,15 @@ public class TwistySkewb extends ShapeHexahedron
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
     switch(getNumLayers()[0])
       {
-      case 2: return ObjectType.SKEW_2.ordinal();
-      case 3: return ObjectType.SKEW_3.ordinal();
+      case 2: return new ObjectSignature(ObjectType.SKEW_2);
+      case 3: return new ObjectSignature(ObjectType.SKEW_3);
       }
 
-    return ObjectType.SKEW_2.ordinal();
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -529,7 +530,7 @@ public class TwistySkewb extends ShapeHexahedron
       case 2: return "Skewb";
       case 3: return "Master Skewb";
       }
-    return "Skewb";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -541,7 +542,7 @@ public class TwistySkewb extends ShapeHexahedron
       case 2: return "Tony Durham";
       case 3: return "Katsuhiko Okamoto";
       }
-    return "Tony Durham";
+    return null;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index 6118782c..57450922 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -25,6 +25,7 @@ import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.helpers.ObjectFaceShape;
+import org.distorted.objectlib.helpers.ObjectSignature;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.scrambling.ScrambleState;
@@ -274,9 +275,9 @@ public class TwistySquare1 extends TwistySquare
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  public long getSignature()
+  public ObjectSignature getSignature()
     {
-    return ObjectType.SQU1_3.ordinal();
+    return new ObjectSignature(ObjectType.SQU1_3);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
